--
-- Filename: HighPressureWasherInfo.lua
-- Author: Ian898
-- Date: 02/06/2022
-- version: 1.0.0.0
--

HighPressureWasherInfo = {}

function HighPressureWasherInfo:inj_HPWL_update(dt)
    local hud = g_currentMission.hud

    if not g_noHudModeEnabled and not hud.isMenuVisible and not hud.vehicleNameDisplay:getVisible() then

        if self.HighPressureWasherInfo == nil then

            self.HighPressureWasherInfo = HUDTextDisplay.new(0.5, g_safeFrameOffsetY, HUD.TEXT_SIZE.VEHICLE_NAME, RenderText.ALIGN_CENTER, HUD.COLOR.VEHICLE_NAME, true)
            self.HighPressureWasherInfoAnimationTime = 1000
            self.HighPressureWasherInfoAnimationDelta = 0
            self.HighPressureWasherInfo:setAlpha(0)

            local height = getTextHeight(self.HighPressureWasherInfo.screenTextSize, self.HighPressureWasherInfo.text)
            self.HighPressureWasherInfo.initialPosY = g_safeFrameOffsetY + height
            self.HighPressureWasherInfo:setPosition(nil, self.HighPressureWasherInfo.initialPosY)
            self.HighPressureWasherInfo:setTextShadow(true, HUD.COLOR.VEHICLE_NAME_SHADOW)
            self.HighPressureWasherInfo:setVisible(false, false)

        else

            if self.foundVehicle ~= nil then
                local vehicleName = g_currentMission:getVehicleName(self.foundVehicle)
                self.HighPressureWasherInfo:setText(string.format("%s: %s %%", g_i18n:getText("setting_dirt"), math.floor(self.foundVehicle.spec_washable:getDirtAmount() * 100)).."\n"..vehicleName)
                self.HighPressureWasherInfo:setVisible(true, true)
                if self.doWashing then
                    self.HighPressureWasherInfoTimer = 1500
                end
            end

            if not self.doWashing then
                if self.HighPressureWasherInfo:getVisible() then
                    if self.HighPressureWasherInfoTimer ~= nil then
                        if self.HighPressureWasherInfoTimer <= 0 then
                            self.HighPressureWasherInfo:setVisible(false, true)
                        else
                            self.HighPressureWasherInfoTimer = self.HighPressureWasherInfoTimer - dt
                        end
                    end
                end
            end

            if self.HighPressureWasherInfoAnimationTime ~= 0 or self.HighPressureWasherInfo:getVisible() then

                if self.HighPressureWasherInfo:getVisible() then
                    if self.HighPressureWasherInfoAnimationDelta < self.HighPressureWasherInfoAnimationTime then
                        self.HighPressureWasherInfoAnimationDelta = math.min(self.HighPressureWasherInfoAnimationDelta + dt, self.HighPressureWasherInfoAnimationTime)
                    end
                else
                    if self.HighPressureWasherInfoAnimationDelta > 0 then
                        self.HighPressureWasherInfoAnimationDelta = math.max(self.HighPressureWasherInfoAnimationDelta - dt, 0)
                    end
                end
                local alpha = MathUtil.clamp(self.HighPressureWasherInfoAnimationDelta / self.HighPressureWasherInfoAnimationTime, 0, 1)
                self.HighPressureWasherInfo:setAlpha(alpha)

                self.HighPressureWasherInfo:draw()
            end
        end

    end
end

HighPressureWasherLance.update = Utils.appendedFunction(HighPressureWasherLance.update, HighPressureWasherInfo.inj_HPWL_update)